﻿using EEMSMain.Data;
using EEMSMain.Views;
using System.IO;
using System.Windows;
using System.Windows.Input;
using UICommon.CommonContainer;

namespace EEMSMain;

/// <summary>
/// Interaction logic for App.xaml
/// </summary>
public partial class App : PrismApplication
{
    protected override Window CreateShell()
    {
        return Container.Resolve<MainWindow>();
    }

    protected override void RegisterTypes(IContainerRegistry containerRegistry)
    {
        containerRegistry.Register<ICommonContainer, CommonContainer>();
        containerRegistry.RegisterSingleton<ContainerManager>();
    }


    protected override IModuleCatalog CreateModuleCatalog()
    {
        return new DirectoryModuleCatalog() { ModulePath = Path.Combine(Environment.CurrentDirectory, "Modules") };
    }
}

public class CommonContainer(IRegionManager regionManager,
        IModuleManager moduleManager, ContainerManager containerManager) : ICommonContainer
{
    public string MainReginName => "MainRegion";

    void ICommonContainer.AddModule(string name)
    {
        moduleManager.LoadModule(name);
    }

    void ICommonContainer.AddNavigation(ContainerInfo containerInfo)
    {
        if (containerInfo.IsHidden)
            return;

        containerManager.Containers ??= [];
        if (!containerManager.Containers.ContainsKey(containerInfo.Index))
        {
            containerManager.Containers[containerInfo.Index] = containerInfo;
            goto Rest;
        }

        Dictionary<int, ContainerInfo> cache = [];

        foreach (KeyValuePair<int, ContainerInfo> container in containerManager.Containers)
        {
            
        }



    Rest:
        if (containerInfo.IsDefault)
            regionManager.RequestNavigate(MainReginName, containerInfo.Name);
    }
}